
$title	Sample file for learning how to use GAMS and GAMS-LST mode.

$ONTEXT

Time-stamp: 	<2001-10-24 10:04:05 ged9203>

Filename:	"gams-sample.gms"
Author:		Shiro Takeda
e-mail:		<ged9203@srv.cc.hit-u.ac.jp>
First-written:	<2001/08/13>
Version:	1.07


Comment:

	This gms file is written to show how to use GAMS and GAMS-LST
	mode.

Note:

	Since version 1.07, the new mode called GAMS-TEMPLATE is added!  See
	the GAMS-TEMPLATE part below!

	First, Sorry for my bad English :-)

	Notations like "C-cv" follow the Emacs convention.
	For example,
	`C-cv' ==>  Type "Control key + c" and then type "v" key.
	`M-q'  ==>  Type "Meta (or Alt) + q".

$OFFTEXT

*	----------------------------------------------------------------------
*
*	Basic usage.
*	----------------------------------------------------------------------

*
*  First, try to run GAMS on this file.  Type `C-ct', then you see the
*  following message in the echo line.
*
*
*	Start GAMS (s) or Kill GAMS process (k): 
*
*
*  Type `s', and GAMS will start.
*
*  When the GAMS process finishes, type `C-cv' to switch to the LST file
*  buffer.
*
*  In the LST buffer, you will see a message "No error message is found"
*  in the echo line.  This message means that the gms file is compiled
*  successfully without any error.
*
*  Type `i' (or `j') to jump back to the gms file buffer.
*
*  Next, uncomment the following line (delete *) and run GAMS (type `C-ct'
*  and type `s').
*
*	 Uncomment this line.  Error is here.
*
*  Then switch to the LST buffer (C-cv) and you will see two windows and a
*  message in the echo line
*
* 	Key: `g' = Jump to the error place, `i' or `j'= Jump to the input file.
*
*  One window displays an error line, and the other displays error meaning.
*
* In the upper window, the following message will displayed.
*
*
*	    52  *
*	    53  *  Next, uncomment the following line (delete *) and run GAMS (type `C-ct'
*	    54  *  and type `s').
*	    55  *
*	    56           Uncomment this line.  Error is here.
*	  ***                    $140 $36   $342            $342
*	    57  *
*	    58  *  Then switch to the LST buffer (C-cv) and you will see two windows and a
*	    59  *  message "If you want to jump to the error place in the program file,
*
*
*  This is standard syntax error message in LST files.  This message
*  indicates the error line and its error number ($140).
*
*  At the same time, the lower window shows the meaning of error with
*  number 140.  In this case, "Unknown symbol".
*
*
*	 140  Unknown symbol
*	 342  Illegal suffix syntax - has to start with a letter

*	  *** 4 ERROR(S)   0 WARNING(S)


*	 COMPILATION TIME     =        0.060 SECONDS    0.7 Mb      WIN200-121
*
*
*  If you type `e' in the LST file buffer, you can go to the first error
*  place from anywhere in the buffer.  Try it.
*
*  Next, type `g' in the LST buffer and you will jump back to the error
*  line in the program file buffer.  
*
*  Repeating the same procedure
*
*		Run GAMS (`C-ct' and `s').
*		Switch to LST buffer (C-cv).
*		See the error line and its meaning.
*		Jump back to the error line in the program file buffer (`g')
*
*  you can easily debug your GMS file.

*
*  The difference between `g' and `j' (`i').
*
*  If a error exists, the the following message will appear in the echo line.
*
*
* 	Key: `g' = Jump to the error place, `i' or `j'= Jump to the input file.
*
*
*  In the example above, there is only one program file, that is, this
*  "gams-sample.gms".  In this case, `g' and `j' have the same effect.  But
*  there may be many program files if you use $INCLUDE etc. and errors may be
*  included in subroutine files.
*
*  `g' = Jump to the error place ==> Jump to the file where the error exists
*  (it may be a subroutine file).

*  `j' or `i' = Jump to the input file. ==> The input file is the top level
*  program file (its name is taken from the FILE SUMMARY field in the LST
*  file.)


*  When you encounter another type of errors, only the error line is
*  displayed.  For example, uncomment the line "* b = 1/a;" below (delete
*  *) and run GAMS and type `C-cv'.

PARAMETER
	a
	b
;
a = 0;
* b = 1/a;
*
*  Type `L' on the following error line
*
*
*	 *** Exec Error 0 at line 117 .. Division by zero
*
*
*  then you will jump to the error line (117).  Moreover, type `j' and you
*  jump to the GMS file.
*

*	----------------------------------------------------------------------
*
*	Other commands in GAMS mode.
*	----------------------------------------------------------------------

***  Process handling.
*
*  As described above, you are able to start GAMS process by typing
*  `C-cts'.  Moreover, if you attach the universal argument (i.e. C-u), you
*  are able to edit the command line before starting process.
*
*  If you type `C-uC-cts', you see
*
*	Start GAMS (s) or Kill GAMS process (k):
*
*  If you type `s' here, you encounter a message like
*
*	Edit command if you want:  gams gams-sample.gms
*
*  and you can edit the command line.
*
*  If you type `k' when a GAMS process is running, you can kill (stop) the
*  process.  Uncomment the following programs and try them.
*
*  (1) `C-ct'
*  (2) `s'
*  (3) `C-ct' while a GAMS process running.
*  (4) `k'
*
* 	 SET	i	/1*5000/;
* 	 PARAMETER
* 	 x(i)
* 	 y(i)
* 	 ;
* 	 x("1") = 0;
* 	 LOOP(i,
* 	 	x(i+1) = 0.1 + x(i);
* 	 	);
* 	 LOOP(i,
* 	 	y(i) = sin(x(i));
* 	 );
* 	 DISPLAY y;
*

***  GAMS statement completions.
*
*  You can insert GAMS statements with completion.  Type `C-ck', then the
*  following message will appear in the echo line.
*
*
*	Insert statement (default = SET):
*
*
*  Type SPACE or TAB key and the list of candidates will appear.  If you type
*  RETURN, the default value `SET' is inserted.  Or if you type, for example,
*  `v' and `SPACE', and the statement `VARIABLE' will be automatically inserted
*  in the minibuffer.  
*
*  Similarly, dollar control options can be inserted with completion.  In
*  this case, type `C-cd' or `$'.
*
*  There are 4 ways to insert `$' itself.
*   
*	1) Type `$$'.
*	2) Type `$@'.
*	3) Type `C-cd$'.
*	2) Type `C-cd@'.
*

***  Automatic registration of a new statement.
*
*  If you are to insert a statement not registered by default, you can register
*  it for future use.  For example, if you type `abort' like
*
*
*	Insert statement (default = SET): abort
*
*
*  and type `RETURN', then you are asked
*
*
*	Store `abort' for future use?  Type `y' if yes: 
*
*
*  If you type `y' here, the statement `abort' is registered and it is included
*  in the list of candidates of statement completion.  These registered
*  statements are saved in the file "~/.gams-statement".  If you have registered
*  unnecessary statements, open the file "~/.gams-statement" and delete them
*  manually.
*
*  GAMS has a lot of statements.  But by default only basic statements are
*  registered in gams.el.  So, please register commands that you frequently use
*  by yourself.
*


***  Quotation and parenthesis.
*
*  Type `, ", or (, and the corresponding ', ", and ) will be automatically
*  inserted if lisp variables `gams-close-paren-always',
*  `gams-close-double-quotation-always' and
*  `gams-close-single-quotation-always' are assigned non-nill.
*

***  Insert user defined comment template.
*
*  To write a gms file that other people (or yourself) can understand
*  easily, it is an good idea to use comments effectively.  You can insert
*  a comment template by typing `C-co' (gams-insert-comment).  Inserted
*  template is defined by a variable `gams-user-comment'.  You can change
*  the value of this variable.  For example, I put the following in my
*  .emacs
*
*
*	 (setq gams-user-comment
*	       "*	------------------------------------------------------------------------
*	
*	 *	%
*	 *	------------------------------------------------------------------------
*	 ")
*
*

***  GAMS-TEMPLATE.
*
*  GAMS-TEMPLATE mode (binded to `C-ce' by default) enables you to handle
*  templates easily.  You can easily insert, re-edit, delete, rename, order,
*  and add templates.
*
*  At my web site, there is a sample template file "dot-gams-template".
*  Download and save it as ".gams-template" in your home directory.  To start
*  GAMS-TEMPLATE mode, type `C-ce' in the GAMS mode buffer.  If you want to
*  know the commands in GAMS-TEMPLATE mode, type `h' in the *Template List*
*  buffer.
*
*

***	Fill paragraph.
*
*  Put the cursor in the next commented out paragraph and type `M-q'.  


*	Put the cursor around here!  This is a sample paragraph.  This is a sample paragraph.  This is a sample paragraph.  This is a sample paragraph.  This is a sample paragraph.  This is a sample paragraph.  This is a sample paragraph....

$ONTEXT

    Put the cursor around here!  This is a sample paragraph.  This is a sample paragraph.  This is a sample paragraph.  This is a sample paragraph.  This is a sample paragraph.  This is a sample paragraph.  This is a sample paragraph....

$OFFTEXT


*  This makes two paragraph respectively like


*	Put the cursor around here!  This is a sample paragraph.  This is a
*	sample paragraph.  This is a sample paragraph.  This is a sample
*	paragraph.  This is a sample paragraph.  This is a sample paragraph.
*	This is a sample paragraph....

$ONTEXT

    Put the cursor around here!  This is a sample paragraph.  This is a sample
    paragraph.  This is a sample paragraph.  This is a sample paragraph.  This
    is a sample paragraph.  This is a sample paragraph.  This is a sample
    paragraph....

$OFFTEXT

*
*

***	Misc.
*
*


*	----------------------------------------------------------------------
*
*	Other commands in GAMS LST mode.
*	----------------------------------------------------------------------

*  If you type `M-x help RETURN' and `m' in a LST file buffer, you can
*  read the simple explanation of GAMS LST mode (or type `?' in a LST file
*  buffer).  It is like this:

$ONTEXT

gams-lst-mode is an interactive Lisp function in `gams-mode'.
(gams-lst-mode)

Major mode for viewing gams LST file. 

The following commands are available in the GAMS-LST mode:

'e' - Jump to the error and show its number and meaning.
'g' - Jump back to the error place in the program file.
'i'  - Jump to the input file.
'j'  - Jump to the input (GMS) file.
'z' - Close the buffer.
'?' - Display this help.

's(S)' - Jump to the next (previous) SOLVER SUMMARY.
'r(R)' - Jump to the next (previous) REPORT SUMMARY.
'v(V)' - Jump to the next (previous) VAR entry.
'a(A)' - Jump to the next (previous) EQU entry.
'p(P)' - Jump to the next (previous) PARAMETER entry.

'l' - Jump to a line you specify.
'L' - Jump to a line.

'SPC' - Scroll up.
'delete' - Scroll down.
'1' - Widen the window.
'2' - Split the window.
'm' - Move frame.
'f' - Resize frame.
'u' - Move a cursor to the other window.

$OFFTEXT

*  The first item in each line indicates the key assignment of each
*  command.  Try each command by yourself.
